'------------------------------------------------------------------------------
'
'  COMDLG32.INC -- Windows API Common Dialog declarations for PowerBASIC
'
'  Copyright (C) 1997-2002 PowerBASIC, Inc.
'  Portions Copyright (C) 1992-1999 Microsoft Corporation
'
'  Last Update: 1 April 2002
' MCM CHANGES
'  08/05/03 renamed structure OPENFILENAME5 to OPENFILENAMEEX
'
'  This file is not compatible with Visual Basic.  It uses the correct
'  data type as defined in the Microsoft SDK for Windows for all API calls.
'  This includes data types which are not natively supported in Visual Basic
'  such as unsigned integers and ASCIIZ strings.
'
'  You have a royalty-free right to use, modify, reproduce and distribute
'  this file (and/or any modified version) in any way you find useful,
'  provided that you agree that both PowerBASIC and Microsoft have no
'  warranty, obligation or liability for its contents.  Refer to the
'  PowerBASIC DLL Compiler Reference Guide for further information.
'  2/16/03 Equates available: %NOPRINTDLG
'                             %NOFILEDLG (removes OPenFileDialog and SaveFileDialog
'
'------------------------------------------------------------------------------

#IF NOT %DEF(%COMDLG32_INC)

%COMDLG32_INC = 1

'
' Pull in Windows includes if necessary
'
#IF NOT %DEF(%WINAPI)
    #INCLUDE "win32api.inc"
#ENDIF


' Common dialog error codes

%CDERR_DIALOGFAILURE            = &HFFFF
%CDERR_GENERALCODES             = &H0000
%CDERR_STRUCTSIZE               = &H0001
%CDERR_INITIALIZATION           = &H0002
%CDERR_NOTEMPLATE               = &H0003
%CDERR_NOHINSTANCE              = &H0004
%CDERR_LOADSTRFAILURE           = &H0005
%CDERR_FINDRESFAILURE           = &H0006
%CDERR_LOADRESFAILURE           = &H0007
%CDERR_LOCKRESFAILURE           = &H0008
%CDERR_MEMALLOCFAILURE          = &H0009
%CDERR_MEMLOCKFAILURE           = &H000A
%CDERR_NOHOOK                   = &H000B
%CDERR_REGISTERMSGFAIL          = &H000C

DECLARE FUNCTION CommDlgExtendedError LIB "COMDLG32.DLL" ALIAS "CommDlgExtendedError" () AS DWORD


'-----------------------------------------------------------------------------
' ChooseColor common dialog

%CC_RGBINIT                     = &H00000001???
%CC_FULLOPEN                    = &H00000002???
%CC_PREVENTFULLOPEN             = &H00000004???
%CC_SHOWHELP                    = &H00000008???
%CC_ENABLEHOOK                  = &H00000010???
%CC_ENABLETEMPLATE              = &H00000020???
%CC_ENABLETEMPLATEHANDLE        = &H00000040???
%CC_SOLIDCOLOR                  = &H00000080???
%CC_ANYCOLOR                    = &H00000100???

%CCERR_CHOOSECOLORCODES         = &H5000

TYPE CHOOSECOLORAPI
    lStructSize    AS DWORD
    hwndOwner      AS LONG
    hInstance      AS LONG
    rgbResult      AS DWORD
    lpCustColors   AS DWORD PTR
    Flags          AS DWORD
    lCustData      AS LONG
    lpfnHook       AS DWORD
    lpTemplateName AS ASCIIZ PTR
END TYPE

DECLARE FUNCTION ChooseColor LIB "COMDLG32.DLL" ALIAS "ChooseColorA" (lpcc AS CHOOSECOLORAPI) AS LONG

'-----------------------------------------------------------------------------
' Find & replace common dialog

TYPE FINDREPLACE
    lStructSize      AS DWORD
    hWndOwner        AS LONG
    hInstance        AS LONG
    Flags            AS DWORD
    lpstrFindWhat    AS ASCIIZ PTR
    lpstrReplaceWith AS ASCIIZ PTR
    wFindWhatLen     AS WORD
    wReplaceWithLen  AS WORD
    lCustData        AS LONG
    lpfnHook         AS DWORD
    lpTemplateName   AS ASCIIZ PTR
END TYPE

%FR_DOWN                        = &H00000001&
%FR_WHOLEWORD                   = &H00000002&
%FR_MATCHCASE                   = &H00000004&
%FR_FINDNEXT                    = &H00000008&
%FR_REPLACE                     = &H00000010&
%FR_REPLACEALL                  = &H00000020&
%FR_DIALOGTERM                  = &H00000040&
%FR_SHOWHELP                    = &H00000080&
%FR_ENABLEHOOK                  = &H00000100&
%FR_ENABLETEMPLATE              = &H00000200&
%FR_NOUPDOWN                    = &H00000400&
%FR_NOMATCHCASE                 = &H00000800&
%FR_NOWHOLEWORD                 = &H00001000&
%FR_ENABLETEMPLATEHANDLE        = &H00002000&
%FR_HIDEUPDOWN                  = &H00004000&
%FR_HIDEMATCHCASE               = &H00008000&
%FR_HIDEWHOLEWORD               = &H00010000&

%FRERR_FINDREPLACECODES         = &H4000
%FRERR_BUFFERLENGTHZERO         = &H4001

DECLARE FUNCTION FindText LIB "COMDLG32.DLL" ALIAS "FindTextA" _
    (lpfr AS FINDREPLACE) AS LONG

DECLARE FUNCTION ReplaceText LIB "COMDLG32.DLL" ALIAS "ReplaceTextA" _
    (lpfr AS FINDREPLACE) AS LONG

'-----------------------------------------------------------------------------
' Font common dialog

%CF_SCREENFONTS                 = &H00000001&
%CF_PRINTERFONTS                = &H00000002&
%CF_BOTH                        = %CF_SCREENFONTS OR %CF_PRINTERFONTS
%CF_SHOWHELP                    = &H00000004&
%CF_ENABLEHOOK                  = &H00000008&
%CF_ENABLETEMPLATE              = &H00000010&
%CF_ENABLETEMPLATEHANDLE        = &H00000020&
%CF_INITTOLOGFONTSTRUCT         = &H00000040&
%CF_USESTYLE                    = &H00000080&
%CF_EFFECTS                     = &H00000100&
%CF_APPLY                       = &H00000200&
%CF_ANSIONLY                    = &H00000400&
%CF_SCRIPTSONLY                 = %CF_ANSIONLY
%CF_NOVECTORFONTS               = &H00000800&
%CF_NOOEMFONTS                  = %CF_NOVECTORFONTS
%CF_NOSIMULATIONS               = &H00001000&
%CF_LIMITSIZE                   = &H00002000&
%CF_FIXEDPITCHONLY              = &H00004000&
%CF_WYSIWYG                     = &H00008000& ' must also have CF_SCREENFONTS & CF_PRINTERFONTS
%CF_FORCEFONTEXIST              = &H00010000&
%CF_SCALABLEONLY                = &H00020000&
%CF_TTONLY                      = &H00040000&
%CF_NOFACESEL                   = &H00080000&
%CF_NOSTYLESEL                  = &H00100000&
%CF_NOSIZESEL                   = &H00200000&
%CF_SELECTSCRIPT                = &H00400000&
%CF_NOSCRIPTSEL                 = &H00800000&
%CF_NOVERTFONTS                 = &H01000000&

%CFERR_CHOOSEFONTCODES          = &H2000
%CFERR_NOFONTS                  = &H2001
%CFERR_MAXLESSTHANMIN           = &H2002

#IF NOT %DEF(%LF_FACESIZE)
    %LF_FACESIZE                      = 32
    %LF_FULLFACESIZE                  = 64
#ENDIF

TYPE CHOOSEFONTAPI
    lStructSize    AS LONG
    hWndOwner      AS LONG
    hDC            AS LONG
    lpLogFont      AS LOGFONT PTR
    iPointSize     AS LONG
    Flags          AS LONG
    rgbColors      AS LONG
    lCustData      AS LONG
    lpfnHook       AS DWORD
    lpTemplateName AS ASCIIZ PTR
    hInstance      AS LONG
    lpszStyle      AS ASCIIZ PTR
    nFontType      AS WORD
    Alignment      AS WORD
    nSizeMin       AS LONG
    nSizeMax       AS LONG
END TYPE

DECLARE FUNCTION ChooseFont LIB "COMDLG32.DLL" ALIAS "ChooseFontA" _
    (lpcf AS CHOOSEFONTAPI) AS LONG

' these are extra nFontType bits that are added to what is returned to the
' EnumFonts callback routine

#IF NOT %DEF(%WINAPI)
    %SIMULATED_FONTTYPE             = &H8000
    %PRINTER_FONTTYPE               = &H4000
    %SCREEN_FONTTYPE                = &H2000
    %BOLD_FONTTYPE                  = &H0100
    %ITALIC_FONTTYPE                = &H0200
    %REGULAR_FONTTYPE               = &H0400
#ENDIF

%WM_CHOOSEFONT_GETLOGFONT        = %WM_USER + 1
%WM_CHOOSEFONT_SETLOGFONT        = %WM_USER + 101
%WM_CHOOSEFONT_SETFLAGS          = %WM_USER + 102

' strings used to obtain unique window message for communication
' between dialog and caller
$LBSELCHSTRING = "commdlg_LBSelChangedNotify"
$SHAREVISTRING = "commdlg_ShareViolation"
$FILEOKSTRING  = "commdlg_FileNameOK"
$COLOROKSTRING = "commdlg_ColorOK"
$SETRGBSTRING  = "commdlg_SetRGBColor"
$HELPMSGSTRING = "commdlg_help"
$FINDMSGSTRING = "commdlg_FindReplace"

' HIWORD values for lParam of commdlg_LBSelChangeNotify message
%CD_LBSELNOITEMS                = &HFFFF??
%CD_LBSELCHANGE                 = 0
%CD_LBSELSUB                    = 1
%CD_LBSELADD                    = 2

'-----------------------------------------------------------------------------
' Printer common dialog

#IF NOT %DEF(%NOPRINTDLG)

%PD_ALLPAGES                    = &H00000000???
%PD_SELECTION                   = &H00000001???
%PD_PAGENUMS                    = &H00000002???
%PD_NOSELECTION                 = &H00000004???
%PD_NOPAGENUMS                  = &H00000008???
%PD_COLLATE                     = &H00000010???
%PD_PRINTTOFILE                 = &H00000020???
%PD_PRINTSETUP                  = &H00000040???
%PD_NOWARNING                   = &H00000080???
%PD_RETURNDC                    = &H00000100???
%PD_RETURNIC                    = &H00000200???
%PD_RETURNDEFAULT               = &H00000400???
%PD_SHOWHELP                    = &H00000800???
%PD_ENABLEPRINTHOOK             = &H00001000???
%PD_ENABLESETUPHOOK             = &H00002000???
%PD_ENABLEPRINTTEMPLATE         = &H00004000???
%PD_ENABLESETUPTEMPLATE         = &H00008000???
%PD_ENABLEPRINTTEMPLATEHANDLE   = &H00010000???
%PD_ENABLESETUPTEMPLATEHANDLE   = &H00020000???
%PD_USEDEVMODECOPIES            = &H00040000???
%PD_USEDEVMODECOPIESANDCOLLATE  = &H00040000???
%PD_DISABLEPRINTTOFILE          = &H00080000???
%PD_HIDEPRINTTOFILE             = &H00100000???
%PD_NONETWORKBUTTON             = &H00200000???
%PD_CURRENTPAGE                 = &H00400000???
%PD_NOCURRENTPAGE               = &H00800000???
%PD_EXCLUSIONFLAGS              = &H01000000???
%PD_USELARGETEMPLATE            = &H10000000???

'
'  Exclusion flags for PrintDlgEx.
'
%PD_EXCL_COPIESANDCOLLATE = %DM_COPIES OR %DM_COLLATE


'
'  Define the start page for the print dialog when using PrintDlgEx.
'
%START_PAGE_GENERAL           = &HFFFFFFFF???


'
'  Result action ids for PrintDlgEx.
'
%PD_RESULT_CANCEL   = 0
%PD_RESULT_PRINT    = 1
%PD_RESULT_APPLY    = 2


%PDERR_PRINTERCODES      = &H1000
%PDERR_SETUPFAILURE      = &H1001
%PDERR_PARSEFAILURE      = &H1002
%PDERR_RETDEFFAILURE     = &H1003
%PDERR_LOADDRVFAILURE    = &H1004
%PDERR_GETDEVMODEFAIL    = &H1005
%PDERR_INITFAILURE       = &H1006
%PDERR_NODEVICES         = &H1007
%PDERR_NODEFAULTPRN      = &H1008
%PDERR_DNDMMISMATCH      = &H1009
%PDERR_CREATEICFAILURE   = &H100A
%PDERR_PRINTERNOTFOUND   = &H100B
%PDERR_DEFAULTDIFFERENT  = &H100C

%DN_DEFAULTPRN           = &H0001

TYPE PRINTDLGAPI
    lStructSize              AS DWORD
    hWndOwner                AS DWORD
    hDevMode                 AS DWORD
    hDevNames                AS DWORD
    hDC                      AS DWORD
    Flags                    AS DWORD
    nFromPage                AS WORD
    nToPage                  AS WORD
    nMinPage                 AS WORD
    nMaxPage                 AS WORD
    nCopies                  AS WORD
    hInstance                AS DWORD
    lCustData                AS LONG
    lpfnPrintHook            AS DWORD
    lpfnSetupHook            AS DWORD
    lpPrintTemplateName      AS ASCIIZ PTR
    lpPrintSetupTemplateName AS ASCIIZ PTR
    hPrintTemplate           AS DWORD
    hSetupTemplate           AS DWORD
END TYPE

DECLARE FUNCTION PrintDlg LIB "COMDLG32.DLL" ALIAS "PrintDlgA" _
    (lpPd AS PRINTDLGAPI) AS LONG

'
'  Page Range structure for PrintDlgEx.
'
TYPE PRINTPAGERANGE
   nFromPage AS DWORD
   nToPage AS DWORD
END TYPE


'
'  PrintDlgEx structure.
'
TYPE PRINTDLGEXAPI
   lStructSize AS DWORD                     ' size of structure in bytes
   hwndOwner AS DWORD                       ' caller's window handle
   hDevMode AS DWORD                        ' handle to DevMode
   hDevNames AS DWORD                       ' handle to DevNames
   hDC AS DWORD                             ' printer DC/IC or NULL
   Flags AS DWORD                           ' PD_ flags
   Flags2 AS DWORD                          ' reserved
   ExclusionFlags AS DWORD                  ' items to exclude from driver pages
   nPageRanges AS DWORD                     ' number of page ranges
   nMaxPageRanges AS DWORD                  ' max number of page ranges
   lpPageRanges AS PRINTPAGERANGE PTR       ' array of page ranges
   nMinPage AS DWORD                        ' min page number
   nMaxPage AS DWORD                        ' max page number
   nCopies AS DWORD                         ' number of copies
   hInstance AS DWORD                       ' instance handle
   lpPrintTemplateName AS ASCIIZ PTR        ' template name for app specific area
   lpCallback AS DWORD                      ' app callback interface
   nPropertyPages AS DWORD                  ' number of app property pages in lphPropertyPages
   lphPropertyPages AS DWORD PTR            ' array of app property page handles
   nStartPage AS DWORD                      ' start page id
   dwResultAction AS DWORD                  ' result action if S_OK is returned
END TYPE

DECLARE FUNCTION PrintDlgEx LIB "COMDLG32.DLL" ALIAS "PrintDlgExA" _
    (lpPde AS PRINTDLGEXAPI) AS LONG


GLOBAL save_hDevMode  AS DWORD ' retain printer selection info
GLOBAL save_hDevNames AS DWORD '  during the entire process

FUNCTION PrinterDialog (BYVAL hWnd AS DWORD, _      ' parent window
                        Flags AS DWORD, _           ' dialog flags
                        hDC AS DWORD, _             ' hDC of printer
                        nCopies AS WORD, _          ' Number of Copies
                        nFromPage AS WORD, _        ' From page number
                        nToPage AS WORD, _          ' To page number
                        BYVAL nMinPage AS WORD, _   ' Minimum page number
                        BYVAL nMaxPage AS WORD _    ' Maximum page number
                       ) AS LONG

    LOCAL pd AS PRINTDLGAPI

    pd.lStructSize = SIZEOF(pd)
    pd.hDevMode    = save_hDevMode
    pd.hDevNames   = save_hDevNames
    pd.hWndOwner   = hWnd
    pd.Flags       = Flags OR %PD_SHOWHELP
    pd.nCopies     = nCopies
    pd.nFromPage   = MAX(nFromPage, nMinPage)
    pd.nToPage     = MAX(MIN(nToPage, nMaxPage), nMaxPage)
    pd.nMinPage    = nMinPage
    pd.nMaxPage    = nMaxPage

    IF PrintDlg(pd) THEN
        hDC            = pd.hDC
        nCopies        = pd.nCopies
        nFromPage      = pd.nFromPage
        nToPage        = pd.nToPage
        Flags          = pd.Flags
        save_hDevMode  = pd.hDevMode
        save_hDevNames = pd.hDevNames
        FUNCTION = %TRUE
    END IF

END FUNCTION

FUNCTION PrinterSetup (BYVAL hWnd AS DWORD) AS LONG

    LOCAL pd AS PRINTDLGAPI

    pd.lStructSize = SIZEOF(pd)
    pd.hDevMode    = save_hDevMode
    pd.hDevNames   = save_hDevNames
    pd.hWndOwner   = hWnd
    pd.Flags       = %PD_SHOWHELP OR %PD_PRINTSETUP

    IF PrintDlg(pd) THEN
        save_hDevMode  = pd.hDevMode
        save_hDevNames = pd.hDevNames
        FUNCTION = %TRUE
    END IF

END FUNCTION

#ENDIF ' #IF NOT %DEF(%NOPRINTDLG)

'-----------------------------------------------------------------------------
' Filename common dialogs

%OFN_READONLY             = &H00000001
%OFN_OVERWRITEPROMPT      = &H00000002
%OFN_HIDEREADONLY         = &H00000004
%OFN_NOCHANGEDIR          = &H00000008
%OFN_SHOWHELP             = &H00000010
%OFN_ENABLEHOOK           = &H00000020
%OFN_ENABLETEMPLATE       = &H00000040
%OFN_ENABLETEMPLATEHANDLE = &H00000080
%OFN_NOVALIDATE           = &H00000100
%OFN_ALLOWMULTISELECT     = &H00000200
%OFN_EXTENSIONDIFFERENT   = &H00000400
%OFN_PATHMUSTEXIST        = &H00000800
%OFN_FILEMUSTEXIST        = &H00001000
%OFN_CREATEPROMPT         = &H00002000
%OFN_SHAREAWARE           = &H00004000
%OFN_NOREADONLYRETURN     = &H00008000
%OFN_NOTESTFILECREATE     = &H00010000
%OFN_NONETWORKBUTTON      = &H00020000
%OFN_NOLONGNAMES          = &H00040000 ' force no long names for 4.x modules
%OFN_EXPLORER             = &H00080000 ' new look commdlg
%OFN_NODEREFERENCELINKS   = &H00100000
%OFN_LONGNAMES            = &H00200000 ' force long names for 3.x modules
%OFN_ENABLEINCLUDENOTIFY  = &H00400000 ' send include message to callback
%OFN_ENABLESIZING         = &H00800000
%OFN_DONTADDTORECENT      = &H02000000
%OFN_FORCESHOWHIDDEN      = &H10000000 ' Show All files including System and hidden files

%OFN_EX_NOPLACESBAR       = &H00000001

' Return values for the registered message sent to the hook function
' when a sharing violation occurs.  %OFN_SHAREFALLTHROUGH allows the
' filename to be accepted, %OFN_SHARENOWARN rejects the name but puts
' up no warning (returned when the app has already put up a warning
' message), and %OFN_SHAREWARN puts up the default warning message
' for sharing violations.
'
' Note:  Undefined return values map to OFN_SHAREWARN, but are
'        reserved for future use.

%OFN_SHAREFALLTHROUGH     = 2
%OFN_SHARENOWARN          = 1
%OFN_SHAREWARN            = 0

#IF NOT %DEF(%CDN_FIRST)
%CDN_FIRST               = 0-601       ' common dialog new
#ENDIF
#IF NOT %DEF(%CDN_LAST)
%CDN_LAST                = 0-699
#ENDIF

' Notifications from Open or Save dialog
%CDN_INITDONE         = %CDN_FIRST - &H0000
%CDN_SELCHANGE        = %CDN_FIRST - &H0001
%CDN_FOLDERCHANGE     = %CDN_FIRST - &H0002
%CDN_SHAREVIOLATION   = %CDN_FIRST - &H0003
%CDN_HELP             = %CDN_FIRST - &H0004
%CDN_FILEOK           = %CDN_FIRST - &H0005
%CDN_TYPECHANGE       = %CDN_FIRST - &H0006
%CDN_INCLUDEITEM      = %CDN_FIRST - &H0007

%FNERR_FILENAMECODES      = &H3000
%FNERR_SUBCLASSFAILURE    = &H3001
%FNERR_INVALIDFILENAME    = &H3002
%FNERR_BUFFERTOOSMALL     = &H3003

TYPE OPENFILENAME
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
END TYPE

' updated version of OPENFILENAME for use with Windows 2000, XP and later
' also known AS OPENFILENAMEEX. CAME FROM PB AS OPENFILENAME5

TYPE OPENFILENAMEEX
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
    pvReserved        AS DWORD
    dwReserved        AS DWORD
    FlagsEx           AS DWORD
END TYPE

TYPE OFNOTIFY
    hdr     AS NMHDR
    lpOFN   AS OPENFILENAME PTR
    pszFile AS ASCIIZ PTR
END TYPE

DECLARE FUNCTION GetOpenFileName LIB "COMDLG32.DLL" ALIAS "GetOpenFileNameA" _
    (lpofn AS OPENFILENAME) AS LONG

DECLARE FUNCTION GetSaveFileName LIB "COMDLG32.DLL" ALIAS "GetSaveFileNameA" _
    (lpofn AS OPENFILENAME) AS LONG

DECLARE FUNCTION GetFileTitle LIB "COMDLG32.DLL" ALIAS "GetFileTitleA" _
    (ASCIIZ, ASCIIZ, BYVAL INTEGER) AS INTEGER

#IF NOT %DEF(%NOFILEDLG)

FUNCTION OpenFileDialog (BYVAL hWnd AS DWORD, _           ' parent window
                         BYVAL Caption AS STRING, _       ' caption
                         Filespec AS STRING, _            ' filename
                         BYVAL InitialDir AS STRING, _    ' start directory
                         BYVAL Filter AS STRING, _        ' filename filter
                         BYVAL DefExtension AS STRING, _  ' default extension
                         Flags AS DWORD _                 ' flags
                        ) AS LONG

    LOCAL Ofn           AS OPENFILENAME
    LOCAL szFile        AS ASCIIZ * %MAX_PATH
    LOCAL szFileTitle   AS ASCIIZ * %MAX_PATH
    LOCAL szInitialDir   AS ASCIIZ * %MAX_PATH
    LOCAL szTitle        AS ASCIIZ * %MAX_PATH
    LOCAL szDefExt       AS ASCIIZ * %MAX_EXT

    REPLACE "|" WITH CHR$(0) IN Filter

    IF LEN(InitialDir) = 0 THEN
        InitialDir = CURDIR$
    END IF

    szInitialDir = InitialDir
    szFile       = Filespec
    szDefExt     = DefExtension
    szTitle      = Caption

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(Filter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = VARPTR(szFile)
    ofn.nMaxFile         = SIZEOF(szFile)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = VARPTR(szInitialDir)
    IF LEN(szTitle) THEN
        ofn.lpstrTitle   = VARPTR(szTitle)
    END IF
    ofn.Flags            = Flags
    ofn.lpstrDefExt      = VARPTR(szDefExt)

    FUNCTION = GetOpenFilename(ofn)

    Filespec = szFile
    Flags    = ofn.Flags

END FUNCTION

FUNCTION SaveFileDialog (BYVAL hWnd AS DWORD, _          ' parent window
                         BYVAL Caption AS STRING, _      ' caption
                         Filespec AS STRING, _           ' filename
                         BYVAL InitialDir AS STRING, _   ' start directory
                         BYVAL Filter AS STRING, _       ' filename filter
                         BYVAL DefExtension AS STRING, _ ' default extension
                         Flags AS DWORD _                ' flags
                        ) AS LONG

    LOCAL Ofn           AS OPENFILENAME
    LOCAL szFile        AS ASCIIZ * %MAX_PATH
    LOCAL szFileTitle   AS ASCIIZ * %MAX_PATH
    LOCAL szFilter      AS ASCIIZ * %MAX_PATH
    LOCAL szInitialDir  AS ASCIIZ * %MAX_PATH
    LOCAL szTitle       AS ASCIIZ * %MAX_PATH
    LOCAL szDefExt      AS ASCIIZ * %MAX_EXT

    REPLACE "|" WITH CHR$(0) IN Filter

    IF LEN(InitialDir) = 0 THEN
        InitialDir = CURDIR$
    END IF

    szFilter     = Filter
    szInitialDir = InitialDir
    szFile       = Filespec
    szDefExt     = DefExtension
    szTitle      = Caption

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = VARPTR(szFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = VARPTR(szFile)
    ofn.nMaxFile         = SIZEOF(szFile)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = VARPTR(szInitialDir)
    IF LEN(szTitle) THEN
        ofn.lpstrTitle   = VARPTR(szTitle)
    END IF
    ofn.Flags            = Flags
    ofn.lpstrDefExt      = VARPTR(szDefExt)

    FUNCTION = GetSaveFilename(ofn)

    Filespec = szFile
    Flags    = ofn.Flags

END FUNCTION

#ENDIF ' IF NOT %DEF(%NOFILEDLG)


TYPE PAGESETUPDLGA
    lStructSize        AS DWORD
    hwndOwner          AS DWORD
    hDevMode           AS DWORD
    hDevNames          AS DWORD
    Flags              AS DWORD
    ptPaperSize        AS POINTAPI
    rtMinMargin        AS RECT
    rtMargin           AS RECT
    hInstance          AS DWORD
    lCustData          AS LONG
    lpfnPageSetupHook  AS DWORD
    lpfnPagePaintHook  AS DWORD
    lpPageSetupTemplateName AS ASCIIZ PTR
    hPageSetupTemplate AS DWORD
END TYPE

DECLARE FUNCTION PageSetupDlg LIB "COMDLG32.DLL" ALIAS "PageSetupDlgA" _
    (lpPageSetupDlg AS PAGESETUPDLGA) AS LONG

%PSD_DEFAULTMINMARGINS             = &H00000000 ' default (printer's)
%PSD_INWININIINTLMEASURE           = &H00000000 ' 1st of 4 possible

%PSD_MINMARGINS                    = &H00000001 ' use caller's
%PSD_MARGINS                       = &H00000002 ' use caller's
%PSD_INTHOUSANDTHSOFINCHES         = &H00000004 ' 2nd of 4 possible
%PSD_INHUNDREDTHSOFMILLIMETERS     = &H00000008 ' 3rd of 4 possible
%PSD_DISABLEMARGINS                = &H00000010
%PSD_DISABLEPRINTER                = &H00000020
%PSD_NOWARNING                     = &H00000080 ' must be same as PD_*
%PSD_DISABLEORIENTATION            = &H00000100
%PSD_RETURNDEFAULT                 = &H00000400 ' must be same as PD_*
%PSD_DISABLEPAPER                  = &H00000200
%PSD_SHOWHELP                      = &H00000800 ' must be same as PD_*
%PSD_ENABLEPAGESETUPHOOK           = &H00002000 ' must be same as PD_*
%PSD_ENABLEPAGESETUPTEMPLATE       = &H00008000 ' must be same as PD_*
%PSD_ENABLEPAGESETUPTEMPLATEHANDLE = &H00020000 ' must be same as PD_*
%PSD_ENABLEPAGEPAINTHOOK           = &H00040000
%PSD_DISABLEPAGEPAINTING           = &H00080000
%PSD_NONETWORKBUTTON               = &H00200000 ' must be same as PD_*



#ENDIF ' #IF NOT %DEF(%COMDLG32_INC)
